import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.List;
/**
 * Write a description of class Ground here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Ground extends Actor {
    GreenfootImage basic = new GreenfootImage(26,26);
    GreenfootImage border = new GreenfootImage(26,26);
    GreenfootImage nothing = new GreenfootImage(1,1);
    public Ground() {
        nothing.fill();
        basic.setColor(new Color(120,81,7));
        basic.fill();
        basic.setColor(new Color(0,0,0,225));
        basic.fill();
        setImage(basic);
    }
    
    protected void addedToWorld(World world) {
        if(getX() > getWorld().getWidth() + 21 || getX() < -21 || getY() > getWorld().getHeight()+21 || getY() < -11) {
            setImage(nothing);
        } else {
            setImage(basic);
        }
        world = (Planet)world;
    }
    
    public void act() {
        if(getX() > getWorld().getWidth() + 21 || getX() < -21 || getY() > getWorld().getHeight()+21 || getY() < -11) {
            setImage(nothing);
        } else {
            setImage(basic);
        }
    }    
    
    public void updateImage(int alpha) {
        basic.setColor(new Color(120,81,7));
        basic.fill();
        basic.setColor(new Color(0,0,0,alpha));
        basic.fill();
        updateBorders();
        setImage(basic);
    }
    
    public void updateBorders() {
        List<Ground> top      = getObjectsAtOffset(0,-14,Ground.class);
        List<Ground> left     = getObjectsAtOffset(-14,0,Ground.class);
        List<Ground> right    = getObjectsAtOffset(14,0,Ground.class);
        List<Ground> bot      = getObjectsAtOffset(0,14,Ground.class);
        border.clear();
        if(top.size() == 0) {
            border.setColor(new Color(0,0,0));
            border.fillRect(0,0,26,2);
        }
        if(left.size() == 0) {
            border.setColor(new Color(0,0,0));
            border.fillRect(0,0,2,26);
        }
        if(right.size() == 0) {
            border.setColor(new Color(0,0,0));
            border.fillRect(24,0,2,26);
        }
        if(bot.size() == 0) {
            border.setColor(new Color(0,0,0));
            border.fillRect(0,24,26,2);
        }
        getImage().drawImage(border,0,0);
    }
}
