import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class Smoke here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Smoke extends Actor {
    GreenfootImage basic;
    int Timer;
    int Speed;
    private double x, y;
    public int Direc;
    public Smoke(int direction) {
        Direc = direction;
        Speed = Greenfoot.getRandomNumber(2)+3;
        
        int size = Greenfoot.getRandomNumber(10)+8;
        Timer = size;
        basic = new GreenfootImage(size,size);
        
        int numGen2 = Greenfoot.getRandomNumber(2)+1;
        int numGen3 = Greenfoot.getRandomNumber(5)+25;
        int green = 255/numGen2;
        int blue = 255/numGen3;
        
        basic.setColor(new Color(255,green,blue));
        basic.fillOval(0,0,size-1,size-1);
        setImage(basic);
    }
    
    protected void addedToWorld(World world) {
        x = getX();//assign X-coordinate
        y = getY();//assign Y-coordinate
    }
    
    public void act() {
        Timer--;
        if(Timer > 0 && getImage().getWidth() > 0) {
            double angle = Math.toRadians(Direc);
            x+=Math.cos(angle)*Speed;
            y+=Math.sin(angle)*Speed;
            setLocation((int)Math.round(x), (int)Math.round(y));
            
            getImage().scale(getImage().getWidth()-1,getImage().getHeight()-1);
            
            Actor g = getOneIntersectingObject(Ground.class);
            if(g != null) {
                Direc = Greenfoot.getRandomNumber(180)+180;
            }
        } else {
            getWorld().removeObject(this);
        }
    }    
}
